Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveServiceClient.cs	(revision 5599)
@@ -1484,17 +1681,12 @@
         }
         
-        public HeuristicLab.Clients.Hive.Job AquireJob(System.Guid slaveId)
-        {
-            return base.Channel.AquireJob(slaveId);
-        }
-        
-        public void AbortJob(System.Guid jobId)
-        {
-            base.Channel.AbortJob(jobId);
-        }
-        
-        public HeuristicLab.Clients.Hive.Job PauseJob(HeuristicLab.Clients.Hive.JobData serializedJob)
-        {
-            return base.Channel.PauseJob(serializedJob);
+        public void StopJob(System.Guid jobId)
+        {
+            base.Channel.StopJob(jobId);
+        }
+        
+        public void PauseJob(System.Guid jobId)
+        {
+            base.Channel.PauseJob(jobId);
         }
         
@@ -1504,5 +1696,5 @@
         }
         
-        public HeuristicLab.Clients.Hive.HiveExperiment[] GetHiveExperiments()
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.HiveExperiment> GetHiveExperiments()
         {
             return base.Channel.GetHiveExperiments();
@@ -1524,62 +1716,37 @@
         }
         
-        public HeuristicLab.Clients.Hive.Project GetAllProjects()
-        {
-            return base.Channel.GetAllProjects();
-        }
-        
-        public void CreateProject(HeuristicLab.Clients.Hive.Project project)
-        {
-            base.Channel.CreateProject(project);
-        }
-        
-        public void ChangeProject(HeuristicLab.Clients.Hive.Project project)
-        {
-            base.Channel.ChangeProject(project);
-        }
-        
-        public void DeleteProject(System.Guid projectId)
-        {
-            base.Channel.DeleteProject(projectId);
-        }
-        
-        public HeuristicLab.Clients.Hive.Job[] GetJobsByProject(System.Guid projectId)
-        {
-            return base.Channel.GetJobsByProject(projectId);
-        }
-        
-        public HeuristicLab.Clients.Hive.MessageContainer[] ProcessHeartbeat(HeuristicLab.Clients.Hive.Heartbeat heartbeat)
-        {
-            return base.Channel.ProcessHeartbeat(heartbeat);
-        }
-        
-        public HeuristicLab.Clients.Hive.HivePluginData[] GetPlugins(HeuristicLab.Clients.Hive.HivePlugin[] pluginList)
-        {
-            return base.Channel.GetPlugins(pluginList);
-        }
-        
-        public System.IO.Stream GetStreamedPlugins(HeuristicLab.Clients.Hive.HivePlugin[] pluginList)
-        {
-            return base.Channel.GetStreamedPlugins(pluginList);
-        }
-        
-        public HeuristicLab.Clients.Hive.Appointment[] GetCalendar(System.Guid slaveId)
-        {
-            return base.Channel.GetCalendar(slaveId);
-        }
-        
-        public void SetCalendarStatus(System.Guid clientId, HeuristicLab.Clients.Hive.CalendarState state)
-        {
-            base.Channel.SetCalendarStatus(clientId, state);
-        }
-        
-        public HeuristicLab.Clients.Hive.Appointment[] GetUptimeCalendarForResource(System.Guid guid)
-        {
-            return base.Channel.GetUptimeCalendarForResource(guid);
-        }
-        
-        public void SetUptimeCalendarForResource(System.Guid guid, HeuristicLab.Clients.Hive.Appointment[] appointments, bool isForced)
-        {
-            base.Channel.SetUptimeCalendarForResource(guid, appointments, isForced);
+        public void Hello(HeuristicLab.Clients.Hive.Slave slave)
+        {
+            base.Channel.Hello(slave);
+        }
+        
+        public void GoodBye(System.Guid slaveId)
+        {
+            base.Channel.GoodBye(slaveId);
+        }
+        
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.MessageContainer> Heartbeat(HeuristicLab.Clients.Hive.Heartbeat heartbeat1)
+        {
+            return base.Channel.Heartbeat(heartbeat1);
+        }
+        
+        public System.Guid AddPlugin(HeuristicLab.Clients.Hive.Plugin plugin, System.Collections.Generic.List<HeuristicLab.Clients.Hive.PluginData> pluginData)
+        {
+            return base.Channel.AddPlugin(plugin, pluginData);
+        }
+        
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.Plugin> GetPlugins()
+        {
+            return base.Channel.GetPlugins();
+        }
+        
+        public System.Collections.Generic.List<HeuristicLab.Clients.Hive.PluginData> GetPluginDatas(System.Collections.Generic.List<System.Guid> pluginIds)
+        {
+            return base.Channel.GetPluginDatas(pluginIds);
+        }
+        
+        public System.Guid AddSlave(HeuristicLab.Clients.Hive.Slave slave)
+        {
+            return base.Channel.AddSlave(slave);
         }
         
@@ -1589,32 +1756,12 @@
         }
         
-        public HeuristicLab.Clients.Hive.Slave[] GetSlaves()
-        {
-            return base.Channel.GetSlaves();
-        }
-        
-        public HeuristicLab.Clients.Hive.SlaveGroup[] GetSlaveGroups()
-        {
-            return base.Channel.GetSlaveGroups();
-        }
-        
-        public void DeleteSlaveGroup(System.Guid clientGroupId)
-        {
-            base.Channel.DeleteSlaveGroup(clientGroupId);
-        }
-        
-        public void AddResourceToGroup(System.Guid slaveGroupId, HeuristicLab.Clients.Hive.Resource resource)
-        {
-            base.Channel.AddResourceToGroup(slaveGroupId, resource);
-        }
-        
-        public void RemoveResourceFromGroup(System.Guid slaveGroupId, System.Guid resourceId)
-        {
-            base.Channel.RemoveResourceFromGroup(slaveGroupId, resourceId);
-        }
-        
-        public void UpdateSlave(HeuristicLab.Clients.Hive.Slave slave)
-        {
-            base.Channel.UpdateSlave(slave);
+        public HeuristicLab.Clients.Hive.Slave GetSlave(System.Guid slaveId)
+        {
+            return base.Channel.GetSlave(slaveId);
+        }
+        
+        public HeuristicLab.Clients.Hive.SlaveGroup GetSlaveGroup(System.Guid slaveGroupId)
+        {
+            return base.Channel.GetSlaveGroup(slaveGroupId);
         }
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Job.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Job.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Job.cs	(revision 5599)
@@ -0,0 +1,70 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Clients.Hive {
+
+  public partial class Job : IDeepCloneable {
+
+    public Job() { }
+
+    public void SetState(JobState state) {
+      this.State = state;
+      this.StateLog.Add(new StateLog() { State = state, DateTime = DateTime.Now });
+    }
+
+    public void SetState(JobState state, Guid userId) {
+      this.State = state;
+      this.StateLog.Add(new StateLog() { State = state, DateTime = DateTime.Now, UserId = userId });
+    }
+
+    public void SetState(JobState state, Guid slaveId, string exception) {
+      this.State = state;
+      this.StateLog.Add(new StateLog() { State = state, DateTime = DateTime.Now, SlaveId = slaveId, Exception = exception });
+    }
+
+    protected Job(Job original, Cloner cloner) {
+      this.Priority = original.Priority;
+      this.CoresNeeded = original.CoresNeeded;
+      this.MemoryNeeded = original.MemoryNeeded;
+      this.PluginsNeededIds = new List<Guid>(original.PluginsNeededIds);
+      this.LastHeartbeat = original.LastHeartbeat;
+      this.IsParentJob = original.IsParentJob;
+      this.FinishWhenChildJobsFinished = original.FinishWhenChildJobsFinished;
+      this.ExecutionTime = original.ExecutionTime;
+      this.ParentJobId = original.ParentJobId;
+      this.StateLog = new List<StateLog>(original.StateLog);
+      this.State = original.State;
+      this.Id = original.Id;
+    }
+
+    public IDeepCloneable Clone(Cloner cloner) {
+      return new Job(this, cloner);
+    }
+
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/LightweightJob.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/LightweightJob.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/LightweightJob.cs	(revision 5599)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Clients.Hive {
+
+  public partial class LightweightJob {
+
+    public LightweightJob() {
+      StateLog = new List<StateLog>();
+    }
+
+
+    public LightweightJob(Job job) {
+      this.Id = job.Id;
+      this.ExecutionTime = job.ExecutionTime;
+      this.ParentJobId = job.ParentJobId;
+      this.StateLog = new List<StateLog>(job.StateLog);
+      this.State = job.State;
+    }
+
+    public StateLog CurrentStateLog { get { return StateLog.Last(); } }
+    public DateTime DateCreated { get { return StateLog.First().DateTime; } }
+    public DateTime? DateFinished { get { return CurrentStateLog.State == JobState.Finished ? new DateTime?(CurrentStateLog.DateTime) : null; } }
+
+    public void SetState(JobState state) {
+      this.State = state;
+      this.StateLog.Add(new StateLog() { State = state, DateTime = DateTime.Now });
+    }
+
+    public void SetState(JobState state, Guid userId) {
+      this.State = state;
+      this.StateLog.Add(new StateLog() { State = state, DateTime = DateTime.Now, UserId = userId });
+    }
+
+    public void SetState(JobState state, Guid slaveId, string exception) {
+      this.State = state;
+      this.StateLog.Add(new StateLog() { State = state, DateTime = DateTime.Now, SlaveId = slaveId, Exception = exception });
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/MessageContainer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/MessageContainer.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/MessageContainer.cs	(revision 5599)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Clients.Hive {
+  [StorableClass]
+  public partial class MessageContainer : IDeepCloneable {
+
+    protected MessageContainer() { }
+    public MessageContainer(MessageType message) {
+      Message = message;
+      JobId = Guid.Empty;
+    }
+    public MessageContainer(MessageType message, Guid jobId) {
+      Message = message;
+      JobId = jobId;
+    }
+
+    protected MessageContainer(MessageContainer original, Cloner cloner) {
+      cloner.RegisterClonedObject(original, this);
+      this.Message = original.Message;
+      this.JobId = original.JobId;
+    }
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      return new MessageContainer(this, cloner);
+    }
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceLocator.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceLocator.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceLocator.cs	(revision 5599)
@@ -21,7 +21,5 @@
 
 using System;
-using System.ServiceModel;
 using HeuristicLab.Clients.Common;
-using HeuristicLab.Services.Hive.Common.ServiceContracts;
 
 namespace HeuristicLab.Clients.Hive {
@@ -51,29 +49,43 @@
       set { password = value; }
     }
-    
-    public Disposable<ChannelFactory<IHiveService>> GetService() {
-      if (string.IsNullOrEmpty(username) && string.IsNullOrEmpty(password)) {
-        return ClientFactory.CreateChannelFactory<IHiveService>("wsHttpBinding_IHiveService");
-      } else {
-        return ClientFactory.CreateChannelFactory<IHiveService>("wsHttpBinding_IHiveService", null, username, password);
+
+    private HiveServiceClient NewServiceClient() {
+      HiveServiceClient cl;
+      if (string.IsNullOrEmpty(username) && string.IsNullOrEmpty(password))
+        cl = ClientFactory.CreateClient<HiveServiceClient, IHiveService>();
+      else
+        cl = ClientFactory.CreateClient<HiveServiceClient, IHiveService>(null, null, username, password);
+
+      return cl;
+    }
+
+    public T CallHiveService<T>(Func<IHiveService, T> call) {
+      HiveServiceClient client = NewServiceClient();
+      try {
+        return call(client);
+      }
+      finally {
+        try {
+          client.Close();
+        }
+        catch (Exception) {
+          client.Abort();
+        }
       }
     }
 
     public void CallHiveService(Action<IHiveService> call) {
-      using (var channelFactory = this.GetService()) {
-        var service = channelFactory.Obj.CreateChannel();
-        call(service);
-      } // disposing the channelfactory is done by the disposable object; the channel gets disposed when the channelfactory is disposed
-    }
-
-    private T CallHiveService<T>(Func<IHiveService, T> call) {
-      using (var channelFactory = this.GetService()) {
-        var service = channelFactory.Obj.CreateChannel();
-        return call(service);
-      } // disposing the channelfactory is done by the disposable object; the channel gets disposed when the channelfactory is disposed
-    }
-
-    T IServiceLocator.CallHiveService<T>(Func<IHiveService, T> call) {
-      return CallHiveService<T>(call);
+      HiveServiceClient client = NewServiceClient();
+      try {
+        call(client);
+      }
+      finally {
+        try {
+          client.Close();
+        }
+        catch (Exception) {
+          client.Abort();
+        }
+      }
     }
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Appointment.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Appointment.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Appointment.cs	(revision 5599)
@@ -40,5 +40,6 @@
     public Guid ResourceId { get; set; }
 
-    protected Appointment(Appointment original, Cloner cloner) : base(original, cloner) {
+    protected Appointment(Appointment original, Cloner cloner)
+      : base(original, cloner) {
       this.AllDayEvent = original.AllDayEvent;
       this.EndDate = original.EndDate;
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/MessageContainer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/MessageContainer.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/MessageContainer.cs	(revision 5599)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Runtime.Serialization;
 using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -31,4 +32,5 @@
   [StorableClass]
   [Serializable]
+  [DataContract]
   public class MessageContainer : IDeepCloneable {
 
@@ -54,6 +56,9 @@
 
     [Storable]
+    [DataMember]
     public MessageType Message { get; set; }
+
     [Storable]
+    [DataMember]
     public Guid JobId { get; set; }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/HeuristicLab 3.3.exe.config
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/HeuristicLab 3.3.exe.config	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Tests/HeuristicLab 3.3.exe.config	(revision 5599)
@@ -95,5 +95,5 @@
         </identity>
       </endpoint>
-      <endpoint address="http://localhost:9000/Hive-3.4" binding="wsHttpBinding" bindingConfiguration="wsHttpBinding" contract="HeuristicLab.Services.Hive.Common.ServiceContracts.IHiveService" name="wsHttpBinding_IHiveService">
+      <endpoint address="http://localhost:80/Service.svc" binding="wsHttpBinding" bindingConfiguration="wsHttpBinding" contract="HeuristicLab.Clients.Hive.IHiveService" name="wsHttpBinding_IHiveService">
         <identity>
           <certificate encodedValue="AwAAAAEAAAAUAAAAfEKvcVixnJay+q4hCPFuO0JL5TQgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhCNN5wrUcXMmE/9xwp4TYa9MAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTEwMTAxOTEwNTMxNVoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDXwC5TGcAffd/0oAWHtm0s6YXVXEgXgb1AYmBkkkhkKIFJG/e/Z0KSYbJepmSJD44W3oOAVm+x1DAsZxU79HahDYgWCuHLMm1TLpwSmYOQ0kV3pGHWHhiWV7h7oGLds/eqZ2EOpaNGryfEPnrA4VmxY91vV5/2BTeVSWG6F8lRKQIDAQABo0kwRzBFBgNVHQEEPjA8gBAR7kBnMRHO5gzThEqda0wWoRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghCNN5wrUcXMmE/9xwp4TYa9MAkGBSsOAwIdBQADgYEAoPwEG4QTDXhlxERNDfsZmM2IhEpV42ppz1kEah2oYKDa/ElIMVtvqLv6flVtg18ENN/mEJWiHZ3NyP3qr2Pip+sh+/2WBiSbOaukES/CM7OJn9kJCImH7M/xqM8pxqY8IfgM6iBVrVj9uHqj3j2BBck+cYY8fKyh3CFifMIp6ac=" />
@@ -107,5 +107,5 @@
         <host>
           <baseAddresses>
-            <add baseAddress="http://localhost:9000/Hive-3.4" />
+            <add baseAddress="http://localhost:80/Service.svc" />
           </baseAddresses>
         </host>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HiveService.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HiveService.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.4/HiveService.cs	(revision 5599)
@@ -11,6 +11,7 @@
   /// <summary>
   /// Implementation of the Hive service (interface <see cref="IHiveService"/>).
+  /// We need 'IgnoreExtensionDataObject' Attribute for the slave to work. 
   /// </summary>
-  [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
+  [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall, IgnoreExtensionDataObject = true)]
   public class HiveService : IHiveService {
     private DataAccess.IHiveDao dao {
